org.apache.xerces.util

## Class SoftReferenceSymbolTable

- java.lang.Object
- - org.apache.xerces.util.SymbolTable
  - - org.apache.xerces.util.SoftReferenceSymbolTable

    public class SoftReferenceSymbolTable
    extends SymbolTable

This symbol table uses SoftReferences to its String entries, which means that table entries that have no references to them can be garbage collected when memory is needed. Thus, in documents with very very large numbers of unique strings, using this SymbolTable will prevent an out of memory error from occuring.

Version:
  $Id: SoftReferenceSymbolTable.java 924298 2010-03-17 13:57:20Z mrglavas $
Author:
  Peter McCracken, IBM
See Also:
  `SymbolTable`

### Nested Class Summary

Nested Classes
`protected static class` `SoftReferenceSymbolTable.SREntry` This class is a symbol table entry.
`protected static class` `SoftReferenceSymbolTable.SREntryData`

### Nested classes/interfaces inherited from class org.apache.xerces.util.SymbolTable

`SymbolTable.Entry`

### Field Summary

Fields
`protected SoftReferenceSymbolTable.SREntry[]` `fBuckets`

### Fields inherited from class org.apache.xerces.util.SymbolTable

`fCount, fLoadFactor, fTableSize, fThreshold, TABLE_SIZE`

### Constructor Summary

Constructors
Constructor and Description
`SoftReferenceSymbolTable()` Constructs a new, empty SymbolTable with a default initial capacity (101) and load factor, which is `0.75`.
`SoftReferenceSymbolTable(int initialCapacity)` Constructs a new, empty SymbolTable with the specified initial capacity and default load factor, which is `0.75`.
`SoftReferenceSymbolTable(int initialCapacity, float loadFactor)` Constructs a new, empty SymbolTable with the specified initial capacity and the specified load factor.

### Method Summary

All Methods Instance Methods Concrete Methods
`java.lang.String` `addSymbol(char[] buffer, int offset, int length)` Adds the specified symbol to the symbol table and returns a reference to the unique symbol.
`java.lang.String` `addSymbol(java.lang.String symbol)` Adds the specified symbol to the symbol table and returns a reference to the unique symbol.
`boolean` `containsSymbol(char[] buffer, int offset, int length)` Returns true if the symbol table already contains the specified symbol.
`boolean` `containsSymbol(java.lang.String symbol)` Returns true if the symbol table already contains the specified symbol.
`protected void` `rehash()` Increases the capacity of and internally reorganizes this SymbolTable, in order to accommodate and access its entries more efficiently.

### Methods inherited from class org.apache.xerces.util.SymbolTable

`hash, hash`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### fBuckets

    protected SoftReferenceSymbolTable.SREntry[] fBuckets

### Constructor Detail

#### SoftReferenceSymbolTable

    public SoftReferenceSymbolTable(int initialCapacity,
                                    float loadFactor)

Constructs a new, empty SymbolTable with the specified initial capacity and the specified load factor.

Parameters:
  `initialCapacity` - the initial capacity of the SymbolTable.
  `loadFactor` - the load factor of the SymbolTable.
Throws:
  `java.lang.IllegalArgumentException` - if the initial capacity is less than zero, or if the load factor is nonpositive.

#### SoftReferenceSymbolTable

    public SoftReferenceSymbolTable(int initialCapacity)

Constructs a new, empty SymbolTable with the specified initial capacity and default load factor, which is `0.75`.

Parameters:
  `initialCapacity` - the initial capacity of the hashtable.
Throws:
  `java.lang.IllegalArgumentException` - if the initial capacity is less than zero.

#### SoftReferenceSymbolTable

    public SoftReferenceSymbolTable()

Constructs a new, empty SymbolTable with a default initial capacity (101) and load factor, which is `0.75`.

### Method Detail

#### addSymbol

    public java.lang.String addSymbol(java.lang.String symbol)

Adds the specified symbol to the symbol table and returns a reference to the unique symbol. If the symbol already exists, the previous symbol reference is returned instead, in order guarantee that symbol references remain unique.

Overrides:
  `addSymbol` in class `SymbolTable`
Parameters:
  `symbol` - The new symbol.

#### addSymbol

    public java.lang.String addSymbol(char[] buffer,
                                      int offset,
                                      int length)

Adds the specified symbol to the symbol table and returns a reference to the unique symbol. If the symbol already exists, the previous symbol reference is returned instead, in order guarantee that symbol references remain unique.

Overrides:
  `addSymbol` in class `SymbolTable`
Parameters:
  `buffer` - The buffer containing the new symbol.
  `offset` - The offset into the buffer of the new symbol.
  `length` - The length of the new symbol in the buffer.

#### rehash

    protected void rehash()

Increases the capacity of and internally reorganizes this SymbolTable, in order to accommodate and access its entries more efficiently. This method is called automatically when the number of keys in the SymbolTable exceeds this hashtable's capacity and load factor.

Overrides:
  `rehash` in class `SymbolTable`

#### containsSymbol

    public boolean containsSymbol(java.lang.String symbol)

Returns true if the symbol table already contains the specified symbol.

Overrides:
  `containsSymbol` in class `SymbolTable`
Parameters:
  `symbol` - The symbol to look for.

#### containsSymbol

    public boolean containsSymbol(char[] buffer,
                                  int offset,
                                  int length)

Returns true if the symbol table already contains the specified symbol.

Overrides:
  `containsSymbol` in class `SymbolTable`
Parameters:
  `buffer` - The buffer containing the symbol to look for.
  `offset` - The offset into the buffer.
  `length` - The length of the symbol in the buffer.